Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 2090)
@@ -32,6 +32,6 @@
 	struct	GeoVertex
 	{
-		Index	id;
-		Index	bonefrom;
+		Index		id;
+		Index		bonefrom;
 		Vector3	position;
 		Vector2 texcoord;
@@ -88,5 +88,5 @@
 			void Save(Serializer &s);
 
-			// 'Inserts the mesh name into the meshsimplificationsequence
+			// Inserts the mesh name into the meshsimplificationsequence.
 			void putMeshName(char *);
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 1070)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 2090)
@@ -2,4 +2,5 @@
 #define __GEO_MESH_SIMPLIFIER__
 
+#include <map>
 #include	<math.h>
 #include	"GeoMesh.h"
@@ -10,17 +11,100 @@
 //#include "SimplificationMethod.h"
 
+using	namespace	Geometry;
+
 namespace Geometry
 {
+
+	//-----------------------------------------------------------------------
+	//	Class for join triangle holes.
+	//-----------------------------------------------------------------------
+	class _coord_
+	{
+		public:
+			float x,y,z;
+			inline _coord_(	float x	=	0.0f,
+					float y	=	0.0f,
+					float z	=	0.0f)
+			{ this->x = x; this->y = y; this->z = z; }
+
+			inline _coord_(const _coord_ &f)
+			{
+				x	=	f.x;
+				y=f.y;
+				z=f.z;
+			}
+
+			inline _coord_ & operator=(const _coord_ &f)
+			{
+				x	=	f.x;
+				y	=	f.y;
+				z	=	f.z;
+
+				return *this;
+			}
+
+			inline bool operator<(const _coord_ &f) const
+			{
+				if (x<f.x-0.0001) return true;
+				if (x>f.x+0.0001) return false;
+				if (y<f.y-0.0001) return true;
+				if (y>f.y+0.0001) return false;
+				if (z<f.z-0.0001) return true;
+				if (z>f.z+0.0001) return false;
+
+				return	false;
+			}
+	};
+
+	//-----------------------------------------------------------------------
+	//	Class tha implements a double-linked map.
+	//-----------------------------------------------------------------------
+	class	EdgesMultimap
+	{
+		private:
+			multimap<int,int>	edges;
+		public:
+			EdgesMultimap();
+			~EdgesMultimap();
+			void	insert(int v1,int v2);
+			void	remove(int v1,int v2);
+			void	contract(int v1,int v2);
+			bool	exists(int v1,int v2);
+	};
+
+	//-----------------------------------------------------------------------
+	//	Class that conserves textures adding new vertices to mesh.
+	//-----------------------------------------------------------------------
+	class	TextureConserver
+	{
+		private:
+			EdgesMultimap			*mEdges;
+			Mesh							*mGeoMesh;
+
+		public:
+			multimap<int,int>	mVertices;
+
+			TextureConserver();
+			~TextureConserver();
+
+			void	JoinVertices(Mesh *mesh);
+
+			MeshSimplificationSequence *
+				WriteRealSimpSeq(MeshSimplificationSequence *simpseq);
+
+			Mesh	*GetMesh();
+	};
+
 	/// Mesh simplificator interface.
 	/** This module is used by both models, general mesh models and the plant and tree models for the trunk and the branches. It contains functions that generate simplified versions of 3D objects made out of triangles. Given a 3D object, this module computes a sequence of geometric transformations that reduce the objects geometric detail while preserving its appearance. For each simplification step, returns a simplification sequence containing the edge to be collapse, the two triangles being removed and the new triangles remapped to the model.\n\n
 
 Inputs:\n
-	- A pointer to the Geometry::Mesh object containing the 3D model to be simplified.
-	.
-    	
+- A pointer to the Geometry::Mesh object containing the 3D model to be simplified.
+.
+
 Outputs:\n
-	-# The simplified mesh, contained in a Geometry::Mesh object.
-	-# Simplification sequence, represented by a Geometry::MeshSimplificationSequence object.
-	*/
+-# The simplified mesh, contained in a Geometry::Mesh object.
+-# Simplification sequence, represented by a Geometry::MeshSimplificationSequence object.
+*/
 
 	class MeshSimplifier
@@ -29,5 +113,5 @@
 			/// Class constructor. Retrieves a pointer to a valid Geometry::Mesh object to simplify.
 			MeshSimplifier(	const Geometry::Mesh	*,
-											Geometry::TIPOFUNC		upb=0);
+					Geometry::TIPOFUNC		upb=0);
 
 			/// Virtual class destructor.
@@ -76,44 +160,61 @@
 	class ViewPointDrivenSimplifier : public MeshSimplifier
 	{
-	private:
-		
-		//	Auxiliar vertex buffer.
-		Geometry::VertexBuffer	*mVB;
-		
-		//	Loads a vmi mesh with a given geometry mesh.
-		VMI::Mesh * initMeshStructure(Geometry::Mesh	*geoMesh);
-
-		//	Loads a geometry mesh with a given vmi mesh.
-		void	loadMesh();
-
-		//	Find vertex in auxiliar vertex buffer.
-		void	findVertex(size_t	submesh, size_t	index);
-		
-		//	Gets the VMI mesh simplification sequence.
-		void	GetMeshSimpSequence();
-
-	public:
-
-		/// Class constructor. Will call Simplifier class constructor.
-		ViewPointDrivenSimplifier(	const Geometry::Mesh 	*geoMesh,
-																Geometry::TIPOFUNC		upb=0);
-
-		/// Class destructor.
-		~ViewPointDrivenSimplifier(void);
-
-		/// Copy constructor
-		//ViewPointDrivenSimplifier(const ViewPointDrivenSimplifier&);
-
-		/// Assignment operator
-		//ViewPointDrivenSimplifier& operator =(const ViewPointDrivenSimplifier&);
-
-		/// Starts the simplification process. Receives as a parameter the LOD factor in a range of [0,1]. Implements the Simplifier::Simplify method to perform an image based simplification.
-		void Simplify(Geometry::Real);
-
-		/// Starts the simplification process. Receives as a parameter the number of vertices of the resulting mesh. Implements the Simplifier::Simplify method to perform an image based simplification.
-		void Simplify(Geometry::uint32);
-
-		// Returns the simplified mesh.
-		//Mesh *GetMesh();
+		private:
+
+			//	Vectors of positions, normals and texture coordinates.
+			vector<Vector3>	vPositions;
+			vector<Vector3>	vNormals;
+			vector<Vector2>	vTexCoords;
+
+			//	Auxiliar vertex buffer.
+			Geometry::VertexBuffer	*mVB;
+
+			//	Set of indices.
+			map<int,int>	mIndexMap;
+
+			//	Join and split vertices to matain texture aspect.
+			TextureConserver	*mTexConserver;
+
+			//	Loads a vmi mesh with a given geometry mesh.
+			VMI::Mesh * initMeshStructure(Geometry::Mesh	*geoMesh);
+
+			//	Loads a geometry mesh with a given vmi mesh.
+			void	loadMesh();
+
+			//	Find vertex in auxiliar vertex buffer.
+			void	findVertex(size_t	submesh, size_t	index);
+
+			//	Gets the VMI mesh simplification sequence.
+			void	GetMeshSimpSequence();
+
+			//	Fill up vectors of positions, normals and texture coordinates.
+			void	fillUpPosNorTC(Mesh	*geoMesh);
+
+			//	Reassigns bones.
+			void bonesReassignament();
+
+		public:
+
+			/// Class constructor. Will call Simplifier class constructor.
+			ViewPointDrivenSimplifier(	const Geometry::Mesh 	*geoMesh,
+					Geometry::TIPOFUNC		upb=0);
+
+			/// Class destructor.
+			~ViewPointDrivenSimplifier(void);
+
+			/// Copy constructor
+			//ViewPointDrivenSimplifier(const ViewPointDrivenSimplifier&);
+
+			/// Assignment operator
+			//ViewPointDrivenSimplifier& operator =(const ViewPointDrivenSimplifier&);
+
+			/// Starts the simplification process. Receives as a parameter the LOD factor in a range of [0,1]. Implements the Simplifier::Simplify method to perform an image based simplification.
+			void Simplify(Geometry::Real);
+
+			/// Starts the simplification process. Receives as a parameter the number of vertices of the resulting mesh. Implements the Simplifier::Simplify method to perform an image based simplification.
+			void Simplify(Geometry::uint32);
+
+			// Returns the simplified mesh.
+			//Mesh *GetMesh();
 	};
 
@@ -122,23 +223,23 @@
 	class GeometryBasedSimplifier : public MeshSimplifier
 	{
-	public:
-		/// Class constructor. Will call Simplifier class constructor.
-		GeometryBasedSimplifier(	const Geometry::Mesh	*geoMesh,
-															Geometry::TIPOFUNC		upb=0);
-
-		/// Class destructor.
-		~GeometryBasedSimplifier(void);
-
-		/// Copy constructor
-		//GeometryBasedSimplifier(const GeometryBasedSimplifier&);
-
-		/// Assignment operator
-		//GeometryBasedSimplifier& operator =(const GeometryBasedSimplifier&);
-
-		/// Starts the simplification process. Receives as a parameter the LOD factor in a range of [0,1]. Implements the Simplifier::Simplify method to perform an image based simplification.
-		void Simplify(Geometry::Real);
-
-		/// Starts the simplification process. Receives as a parameter the number of vertices of the resulting mesh. Implements the Simplifier::Simplify method to perform an image based simplification.
-		void Simplify(Geometry::uint32);
+		public:
+			/// Class constructor. Will call Simplifier class constructor.
+			GeometryBasedSimplifier(	const Geometry::Mesh	*geoMesh,
+					Geometry::TIPOFUNC		upb=0);
+
+			/// Class destructor.
+			~GeometryBasedSimplifier(void);
+
+			/// Copy constructor
+			//GeometryBasedSimplifier(const GeometryBasedSimplifier&);
+
+			/// Assignment operator
+			//GeometryBasedSimplifier& operator =(const GeometryBasedSimplifier&);
+
+			/// Starts the simplification process. Receives as a parameter the LOD factor in a range of [0,1]. Implements the Simplifier::Simplify method to perform an image based simplification.
+			void Simplify(Geometry::Real);
+
+			/// Starts the simplification process. Receives as a parameter the number of vertices of the resulting mesh. Implements the Simplifier::Simplify method to perform an image based simplification.
+			void Simplify(Geometry::uint32);
 	};
 } // end of Geometry namespace;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/gfx/tools/Buffer.h	(revision 2090)
@@ -32,5 +32,7 @@
 	{
 		if( fill == len )
-		resize( len*2 );
+		{
+			resize( len*2 );
+		}
 
 		data[fill] = t;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h	(revision 2090)
@@ -11,4 +11,5 @@
     GLuint *triangles;   // List of triangles
     int enable;
+		int	movable;	//	If vertex is part of a border.
 } Vertex;
 
@@ -22,4 +23,5 @@
 typedef struct _Triangle {
     GLuint		id;         // Triangle id
+    GLuint  group;        // Triangle group
 		GLuint		submesh;		// Triangle submesh	
     GLuint		indices[3]; // Triangle vertices
@@ -45,5 +47,7 @@
 extern void computeTriangleNormal(Vertex *vertices, Triangle *t);
 
+extern Vertex *addVertex(Vertex *list, int *n, float x, float y, float z, int *pos);
 extern int findEdge(Edge *e, GLuint num, GLuint _u, GLuint _v);
+extern Edge *addEdge(Edge *list, int *n, int u, int v, int *pos);
 extern GLboolean findVertex(GLfloat *vertices, GLuint num, GLfloat x, GLfloat y, GLfloat z, int *pos);
 
@@ -55,12 +59,13 @@
 
 extern int *trianglesAdjToEdge(Mesh *mesh, int e, int *n);
-extern int *trianglesAdjToVertex(Mesh *mesh, int v, int *n);
 extern int *verticesAdjToVertex(Mesh *mesh, int v, int *n);
 extern int *edgesAdjToVertex(Mesh *mesh, int v, int *n);
 extern int *edgesAdjToVertices(Mesh *mesh, int *vertices, int numVertices, int *n);
 
+// list of integers
 extern void printItemList(int *list, int n);
 extern int findItem(int *list, int n, int item);
 extern void addItem(int *list, int *n, int item);
+extern void delItem(int *list, int *n, int item);
 
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h	(revision 1007)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h	(revision 2090)
@@ -7,21 +7,75 @@
 #include "bheap.h"
 
+#include	<map>
+
+using	namespace	std;
+
 namespace	VMI
 {
-extern GLdouble computeEdgeCost(Mesh *mesh, int e);
+	extern GLdouble computeEdgeCost(Mesh *mesh, int e);
 
-extern bheap_t *initHeap(Mesh *mesh);
+	extern bheap_t *initHeap(Mesh *mesh);
 
-extern bheap_t *updateHeap(bheap_t *h, Mesh *mesh, Change *c);
+	extern bheap_t *updateHeap(bheap_t *h, Mesh *mesh, Change *c);
 
-extern void simplifyModel(Mesh *mesh, GLuint numDemandedTri);
+	extern void simplifyModel(Mesh *mesh, GLuint numDemandedTri);
 
 
-extern void bh_mydump(Mesh *mesh, bheap_t *h);
-extern GLdouble computeEdgeLength(Vertex *vertices, int u, int v);
+	extern void bh_mydump(Mesh *mesh, bheap_t *h);
+	extern GLdouble computeEdgeLength(Vertex *vertices, int u, int v);
 
-extern void swap(unsigned int *i, unsigned int *j);
-extern void chooseBestEndPoints(Mesh *mesh, int e);
+	extern void chooseBestEndPoints(Mesh *mesh, int e);
 
+	extern void	initVertexMultimap(	Mesh *mesh,
+																	multimap<int,int> &vertexMultimap);
+	/////////////////////////////////////////////////////////////////////////////
+	//	Coordinates class.
+	/////////////////////////////////////////////////////////////////////////////
+	class _float3_
+	{
+		public:
+
+			float x,y,z;
+
+			_float3_(float x=0.0f, float y=0.0f, float z=0.0f)
+			{
+				this->x = x; this->y = y; this->z = z;
+			}
+
+			_float3_(const _float3_ &f)
+			{
+				x=f.x; y=f.y; z=f.z;
+			}
+
+			_float3_ & operator=(const _float3_ &f)
+			{
+				x=f.x; y=f.y; z=f.z; return *this;
+			}
+
+			bool operator<(const _float3_ &f) const
+			{
+				if (x<f.x) return true;
+				if (x>f.x) return false;
+				if (y<f.y) return true;
+				if (y>f.y) return false;
+				if (z<f.z) return true;
+				if (z>f.z) return false;
+				return false;
+			}
+	};
+
+	extern int extractValidEdge(Mesh *mesh,	bheap_t *h);
+
+	extern int	isValidEdge(Mesh	*mesh,	int edge);
+
+	void	deleteVertexOfMap(Mesh	*mesh, int u);
+	bool	compareVertices(Vertex *vertices,int	u,	int v);
+	void	contractInitialMesh(Mesh	*mesh);
+	void	contractTwinVertices(Mesh	*mesh,	int	u,	int	v);
+
+	//	Vectors of positions, normals and texture coordinates.
+	extern	vector<Geometry::Vector3>	vPositions;
+	extern	vector<Geometry::Vector3>	vNormals;
+	extern	vector<Geometry::Vector2>	vTexCoords;
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h	(revision 2090)
@@ -20,8 +20,10 @@
 extern void printFullHistogram(GLuint **histogram, GLuint numCameras, GLuint numTriangles);
 extern void getSWHistogram(GLuint *histogram, GLubyte *pixels);
+extern void getSWHistogramWin(GLuint *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c);
 extern void getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, GLuint *histogram);
 
 extern void resetSWHistogram(GLuint *histogram, GLuint numTriangles);
-
+extern void getBoundingBox(Change *c, GLfloat min[3], GLfloat max[3]);
+extern void getWindow(GLfloat min[3], GLfloat max[3], int minw[2], int maxw[2]);
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/interleave.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/interleave.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/interleave.h	(revision 2090)
@@ -20,4 +20,5 @@
     GLfloat x, y, z;    // position
 } Vertex_;
+extern GLuint vertex_buf, color_buf;
 
 extern void setupInterleave(Mesh *mesh, Color *colors);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h	(revision 2090)
@@ -8,4 +8,5 @@
 #include "mesh.h"
 #include "color.h"
+#include "change.h"
 
 //	For progress update.
@@ -58,4 +59,20 @@
 
 //#define SALIENCY
+
+// Extension added into the filename
+#ifdef KL // Kullback-Leibler
+#define EXT "VKL"
+#endif
+#ifdef MI // Mutual Information
+#define EXT "VMI"
+#endif
+#ifdef HE // Hellinger
+#define EXT "VHE"
+#endif
+#ifdef CS // Chi-Square
+#define EXT "VCS"
+#endif
+
+//#define USE_EDGE_ADJACENCY
 
 #define CHECK_OPENGL_ERROR( cmd ) \
@@ -110,5 +127,6 @@
                  bEnableOffScreen,
                  bSaveLog,
-                 bLoadCamerasFromFile;
+                 bLoadCamerasFromFile,
+								 bRemoveRedundantVertices;
 
 extern GLsizei width, height;
@@ -121,4 +139,5 @@
 
 extern void renderScene(GLuint **histogram, GLuint numCameras);
+extern void renderSceneWin(GLuint **histogram, GLuint numCameras, Change *c);
 
 extern void renderGeometry(void);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h	(revision 2090)
@@ -8,11 +8,13 @@
 namespace	VMI
 {
-extern GLuint computeBackgroundArea(Mesh *mesh, GLuint *histogram);
-extern GLdouble computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t);
 extern GLdouble computeMI(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint cam);
+extern GLdouble decMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c);
+extern GLdouble incMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c);
+
 extern GLdouble computeHE(Mesh *mesh, GLuint *histogram);
 extern GLdouble computeKL(Mesh *mesh, GLuint *histogram);
 extern GLdouble computeCS(Mesh *mesh, GLuint *histogram);
 
+extern GLdouble computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t);
 extern GLdouble computeJS(GLuint **histogram, GLuint numCameras, GLuint j, GLuint k);
 extern GLdouble computeEntropy(GLuint **histogram, GLuint numCameras, GLuint k);
@@ -21,4 +23,5 @@
 
 extern void getProjectedAreas(GLuint **histogram, GLuint numCameras);
+extern void getProjectedAreasWin(GLuint **histogram, GLuint numCameras, Change *c);
 extern void resetProjectedAreas(GLuint **histogram, GLuint numCameras);
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h	(revision 2090)
@@ -14,4 +14,5 @@
 
 extern void computeSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras);
+extern void updateTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, int v);
 
 extern double computeTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint k);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h	(revision 2090)
@@ -14,11 +14,11 @@
 } Color;
 
-extern Color *initColors(GLuint numTriangles);
-extern void fillAllColors(Color *colors, GLuint numTriangles, GLuint begin, GLuint end, GLubyte color);
+extern Color *initColors(GLuint numColors);
+extern void fillAllColors(Color *colors, GLuint numColors, GLuint begin, GLuint end, GLubyte color);
 extern void setColors(Color *colors, GLuint numPasses, GLuint begin, GLuint end);
-extern void setColors2(Color *colors, GLuint numTriangles, GLuint begin, GLuint end);
-extern void setColors3(Color *colors, GLuint numTriangles, GLubyte color);
-extern void setColors4(Color *colors, GLuint numTriangles);
-extern void viewColors(Color *colors, GLuint numTriangles);
+extern void setColors2(Color *colors, GLuint numColors, GLuint begin, GLuint end);
+extern void setColors3(Color *colors, GLuint numColors, GLubyte color);
+extern void setColors4(Color *colors, GLuint numColors);
+extern void viewColors(Color *colors, GLuint numColors);
 
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/bheap.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/bheap.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/bheap.h	(revision 2090)
@@ -15,10 +15,11 @@
  */
 typedef struct {
-    int item;  /* vertex number is used for the item. */
+    int dirty;  /* dirty flag if used for the lazy evaluation */
+    int item;  /* edge number is used for the item. */
     double key;  /* distance is used as the key. */
 } bheap_item_t;
 
 /* Binary heap structure for frontier set in Dijkstra's algorithm.
- * a[] - stores (distance, vertex) pairs of the binary heap.
+ * a[] - stores (distance, edge) pairs of the binary heap.
  * p[] - stores the positions of vertices in the binary heap a[].
  * n - is the size of the binary heap.
@@ -58,4 +59,17 @@
  */
 void bh_delete(bheap_t *h, int item);
+/* bh_mark() marks an item from the binary heap pointed to by h.
+ */
+void bh_mark(bheap_t *h, int item, int flag);
+
+/* bh_get_key() returns the key value of an item from the binary heap pointed 
+ * to by h.
+ */
+double bh_get_key(bheap_t *h, int item);
+
+/* bh_is_dirty() returns the dirty value of an item from the binary heap pointed
+ * to by h.
+ */
+int bh_is_dirty(bheap_t *h, int item);
 
 /* bh_decrease_key() decreases the value of 'item's key and then performs
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 1024)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 2090)
@@ -5,4 +5,5 @@
 #include	<vector>
 #include	<map>
+#include	<GeoMeshSimpSequence.h>
 
 namespace	VMI
@@ -20,4 +21,5 @@
 	} Change;
 
+	/*
 	// Represents a simplification step in the sequence.
 	struct vmiStep
@@ -41,5 +43,23 @@
 	extern	std::vector<vmiStep> mVMISteps;
 
+	//	Vertex info.
+	struct	GeoVertex
+	{
+		Index		id;
+		Index		bonefrom;
+		Vector3	position;
+		Vector2 texcoord;
+		Vector3 normal;
+	};
+
+	//	Vertices added in simplification.
+	std::vector<GeoVertex>	mNewVertices;
+	*/
+
+	// Stores all the simplification steps.
+	extern	Geometry::MeshSimplificationSequence *mSequence;
+
 	extern Change *createChange (Mesh *mesh, int e);
+	extern Change *newChange (Mesh *mesh, int u, int v);
 	extern void writeChange(FILE* file, Change *c);
 	extern void deleteChange(Change *c);
@@ -47,8 +67,8 @@
 
 	extern void modifyTriangle(Triangle *t, int c, int p);
-	extern int isATriangleToModify(Triangle *t, int c, int p);
-	extern int getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified);
+	extern int isATriangleToModify(Triangle *t, int c);
+	extern Triangle *getTrianglesToModify(Mesh *mesh, Change *c, GLuint *numMod);
 	extern int isATriangleToDelete(Triangle *t, int c, int p);
-	extern int getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p);
+	extern Triangle *getTrianglesToDelete(Mesh *mesh, Change *c, GLuint *numDel);
 
 	extern void modifyTriangles(Mesh *mesh, Change *c);
@@ -62,11 +82,16 @@
 	extern void doChange(Mesh *mesh, Change *c);
 	extern void undoChange(Mesh *mesh, Change *c);
-	extern void computeChanges(Mesh *mesh, Change *c);
+	extern void computeChange(Mesh *mesh, Change *c);
+
+	extern void modifyEdges(Mesh *mesh, Change *c);
+  extern void deleteEdges(Mesh *mesh, Change *c);
 
 	//	Save simplification sequence in Geometry Game Tools format.
-	extern void	saveSimplificationSequence(Change	*c);
+	extern void	saveSimplificationSequence(Change	*c, int obligatory);
 
-	extern std::map<int, INTVECTOR> inversemap;
+	//extern std::map<int, INTVECTOR> inversemap;
+	extern void swap(int *i, int *j);
+	extern int hasEdge(Triangle *t, int e);
+	extern void getEdges(Triangle *t, Change *c, int *d, int *a);
 }
-
 #endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h	(revision 2090)
@@ -5,4 +5,5 @@
 
 #define OCTAHEDRON     6  // number of vertices
+#define CUBE           8
 #define ICOSAHEDRON   12
 #define DODECAHEDRON  20
@@ -26,4 +27,5 @@
 extern void drawSphere(Camera *cameras, GLdouble radius, int slices, int stacks);
 extern void drawOctahedron(Camera *cameras, GLdouble r);
+extern void drawCube(Camera *cameras, GLdouble r);
 extern void drawIcosahedron(Camera *cameras, GLdouble r);
 extern void drawDodecahedron(Camera *cameras, GLdouble r);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/interleave.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/interleave.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/interleave.cpp	(revision 2090)
@@ -17,5 +17,5 @@
 static Color   *buf_colors = NULL;
 
-static GLuint vertex_buf = 0,
+GLuint vertex_buf = 0,
        color_buf = 0;
 }
@@ -100,17 +100,7 @@
     setupVertexArray(mesh, colors);
     
-    // Disable the vertex array functionality:
-    glDisableClientState(GL_VERTEX_ARRAY);
-    glDisableClientState(GL_COLOR_ARRAY);
-    
-    glDeleteBuffersARB(1, &vertex_buf);
-    
-    glGenBuffersARB(1, &vertex_buf);
     glBindBufferARB(GL_ARRAY_BUFFER_ARB, vertex_buf);
     glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh->currentNumTriangles * 3 * 3 * sizeof(float), buf_vertices, GL_STATIC_DRAW_ARB); //upload data
     
-    glDeleteBuffersARB(1, &color_buf);
-    
-    glGenBuffersARB(1, &color_buf);
     glBindBufferARB(GL_ARRAY_BUFFER_ARB, color_buf);
     glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh->currentNumTriangles * 3 * sizeof(Color), buf_colors, GL_STATIC_DRAW_ARB); //upload data
@@ -182,10 +172,4 @@
     updateVertexArray(mesh);
     
-    // Disable the vertex array functionality:
-    glDisableClientState(GL_VERTEX_ARRAY);
-    
-    glDeleteBuffersARB(1, &vertex_buf);
-    
-    glGenBuffersARB(1, &vertex_buf);
     glBindBufferARB(GL_ARRAY_BUFFER_ARB, vertex_buf);
     glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh->currentNumTriangles * 3 * 3 * sizeof(float), buf_vertices, GL_STATIC_DRAW_ARB); //upload data
